//>>built
define("dojox/treemap/TreeMap",["dojo/_base/array","dojo/_base/lang","dojo/_base/declare","dojo/_base/event","dojo/_base/Color","dojo/_base/Deferred","dojo/on","dojo/query","dojo/dom-construct","dojo/dom-geometry","dojo/dom-class","dojo/dom-style","./_utils","dijit/_WidgetBase","dojox/widget/_Invalidating","dojox/widget/Selection","dojo/_base/sniff","dojo/uacss"],function(_1,_2,_3,_4,_5,_6,on,_7,_8,_9,_a,_b,_c,_d,_e,_f,has){
return _3("dojox.treemap.TreeMap",[_d,_e,_f],{baseClass:"dojoxTreeMap",store:null,query:{},itemToRenderer:null,_dataChanged:false,rootItem:null,_rootItemChanged:false,tooltipAttr:"",areaAttr:"",_areaChanged:false,labelAttr:"label",labelThreshold:NaN,colorAttr:"",colorModel:null,_coloringChanged:false,groupAttrs:[],groupFuncs:null,_groupFuncs:null,_groupingChanged:false,constructor:function(){
this.itemToRenderer={};
this.invalidatingProperties=["colorModel","groupAttrs","groupFuncs","areaAttr","areaFunc","labelAttr","labelFunc","labelThreshold","tooltipAttr","tooltipFunc","colorAttr","colorFunc","rootItem"];
},getIdentity:function(_10){
return _10.__treeID?_10.__treeID:this.store.getIdentity(_10);
},resize:function(box){
if(box){
_9.setMarginBox(this.domNode,box);
this.invalidateRendering();
}
},postCreate:function(){
this.inherited(arguments);
this.connect(this.domNode,"mouseover",this._onMouseOver);
this.connect(this.domNode,"mouseout",this._onMouseOut);
this.connect(this.domNode,"mouseup",this._onMouseUp);
},buildRendering:function(){
this.inherited(arguments);
this.refreshRendering();
},refreshRendering:function(){
var _11=false;
if(this._dataChanged){
this._dataChanged=false;
this._groupingChanged=true;
this._coloringChanged=true;
}
if(this._groupingChanged){
this._groupingChanged=false;
this._set("rootItem",null);
this._updateTreeMapHierarchy();
_11=true;
}
if(this._rootItemChanged){
this._rootItemChanged=false;
_11=true;
}
if(this._coloringChanged){
this._coloringChanged=false;
if(this.colorModel!=null&&this._data!=null&&this.colorModel.initialize){
this.colorModel.initialize(this._data,_2.hitch(this,function(_12){
return this.colorFunc(_12,this.store);
}));
}
}
if(this._areaChanged){
this._areaChanged=false;
this._removeAreaForGroup();
}
if(this.domNode==undefined||this._items==null){
return;
}
if(_11){
_8.empty(this.domNode);
}
var _13=this.rootItem;
if(_13!=null){
if(this._isLeaf(_13)){
_13=this._getRenderer(_13).parentItem;
}
}
var box=_9.getMarginBox(this.domNode);
if(_13!=null){
this._buildRenderer(this.domNode,null,_13,{x:box.l,y:box.t,w:box.w,h:box.h},0,_11);
}else{
this._buildChildrenRenderers(this.domNode,_13?_13:{__treeRoot:true,children:this._items},0,_11,box);
}
},_setRootItemAttr:function(_14){
this._rootItemChanged=true;
this._set("rootItem",_14);
},_setStoreAttr:function(_15){
if(_15!=null){
var _16=_15.query(this.query);
if(_16.observe){
_16.observe(_2.hitch(this,this._updateItem),true);
}
_6.when(_16,_2.hitch(this,this._initItems));
}else{
this._initItems([]);
}
this._set("store",_15);
},_initItems:function(_17){
this._dataChanged=true;
this._data=_17;
this.invalidateRendering();
},_updateItem:function(_18,_19,_1a){
if(_19!=-1){
if(_1a!=_19){
this._data.splice(_19,1);
}else{
this._data[_1a]=_18;
}
}else{
if(_1a!=-1){
this._data.splice(_1a,0,_18);
}
}
this._dataChanged=true;
this.invalidateRendering();
},_setGroupAttrsAttr:function(_1b){
this._groupingChanged=true;
if(this.groupFuncs==null){
if(_1b!=null){
this._groupFuncs=_1.map(_1b,function(_1c){
return function(_1d){
return _1d[_1c];
};
});
}else{
this._groupFuncs=null;
}
}
this._set("groupAttrs",_1b);
},_setGroupFuncsAttr:function(_1e){
this._groupingChanged=true;
this._set("groupFuncs",this._groupFuncs=_1e);
if(_1e==null&&this.groupAttrs!=null){
this._groupFuncs=_1.map(this.groupAttrs,function(_1f){
return function(_20){
return _20[_1f];
};
});
}
},_setAreaAttrAttr:function(_21){
this._areaChanged=true;
this._set("areaAttr",_21);
},areaFunc:function(_22,_23){
return (this.areaAttr&&this.areaAttr.length>0)?parseFloat(_22[this.areaAttr]):1;
},_setAreaFuncAttr:function(_24){
this._areaChanged=true;
this._set("areaFunc",_24);
},labelFunc:function(_25,_26){
var _27=(this.labelAttr&&this.labelAttr.length>0)?_25[this.labelAttr]:null;
return _27?_27.toString():null;
},tooltipFunc:function(_28,_29){
var _2a=(this.tooltipAttr&&this.tooltipAttr.length>0)?_28[this.tooltipAttr]:null;
return _2a?_2a.toString():null;
},_setColorModelAttr:function(_2b){
this._coloringChanged=true;
this._set("colorModel",_2b);
},_setColorAttrAttr:function(_2c){
this._coloringChanged=true;
this._set("colorAttr",_2c);
},colorFunc:function(_2d,_2e){
var _2f=(this.colorAttr&&this.colorAttr.length>0)?_2d[this.colorAttr]:0;
if(_2f==null){
_2f=0;
}
return parseFloat(_2f);
},_setColorFuncAttr:function(_30){
this._coloringChanged=true;
this._set("colorFunc",_30);
},createRenderer:function(_31,_32,_33){
var div=_8.create("div");
if(_33!="header"){
_b.set(div,"overflow","hidden");
_b.set(div,"position","absolute");
}
return div;
},styleRenderer:function(_34,_35,_36,_37){
switch(_37){
case "leaf":
_b.set(_34,"background",this.getColorForItem(_35).toHex());
case "header":
var _38=this.getLabelForItem(_35);
if(_38&&(isNaN(this.labelThreshold)||_36<this.labelThreshold)){
_34.innerHTML=_38;
}else{
_8.empty(_34);
}
break;
default:
}
},_updateTreeMapHierarchy:function(){
if(this._data==null){
return;
}
if(this._groupFuncs!=null&&this._groupFuncs.length>0){
this._items=_c.group(this._data,this._groupFuncs,dojo.hitch(this,this._getAreaForItem)).children;
}else{
this._items=this._data;
}
},_removeAreaForGroup:function(_39){
var _3a;
if(_39!=null){
if(_39.__treeValue){
delete _39.__treeValue;
_3a=_39.children;
}else{
return;
}
}else{
_3a=this._items;
}
if(_3a){
for(var i=0;i<_3a.length;++i){
this._removeAreaForGroup(_3a[i]);
}
}
},_getAreaForItem:function(_3b){
var _3c=this.areaFunc(_3b,this.store);
return isNaN(_3c)?0:_3c;
},_computeAreaForItem:function(_3d){
var _3e;
if(_3d.__treeID){
_3e=_3d.__treeValue;
if(!_3e){
_3e=0;
var _3f=_3d.children;
for(var i=0;i<_3f.length;++i){
_3e+=this._computeAreaForItem(_3f[i]);
}
_3d.__treeValue=_3e;
}
}else{
_3e=this._getAreaForItem(_3d);
}
return _3e;
},getColorForItem:function(_40){
var _41=this.colorFunc(_40,this.store);
if(this.colorModel!=null){
return this.colorModel.getColor(_41);
}else{
return new _5(_41);
}
},getLabelForItem:function(_42){
return _42.__treeName?_42.__treeName:this.labelFunc(_42,this.store);
},_buildChildrenRenderers:function(_43,_44,_45,_46,_47,_48){
var _49=_44.children;
var box=_9.getMarginBox(_43);
var _4a=_c.solve(_49,box.w,box.h,_2.hitch(this,this._computeAreaForItem),!this.isLeftToRight());
var _4b=_4a.rectangles;
if(_47){
_4b=_1.map(_4b,function(_4c){
_4c.x+=_47.l;
_4c.y+=_47.t;
return _4c;
});
}
var _4d;
for(var j=0;j<_49.length;++j){
_4d=_4b[j];
this._buildRenderer(_43,_44,_49[j],_4d,_45,_46,_48);
}
},_isLeaf:function(_4e){
return !_4e.children;
},_isRoot:function(_4f){
return _4f.__treeRoot;
},_getRenderer:function(_50,_51,_52){
if(_51){
for(var i=0;i<_52.children.length;++i){
if(_52.children[i].item==_50){
return _52.children[i];
}
}
}
return this.itemToRenderer[this.getIdentity(_50)];
},_buildRenderer:function(_53,_54,_55,_56,_57,_58,_59){
var _5a=this._isLeaf(_55);
var _5b=!_58?this._getRenderer(_55,_59,_53):null;
_5b=_5a?this._updateLeafRenderer(_5b,_55,_57):this._updateGroupRenderer(_5b,_55,_57);
if(_58){
_5b.level=_57;
_5b.item=_55;
_5b.parentItem=_54;
this.itemToRenderer[this.getIdentity(_55)]=_5b;
this.updateRenderers(_55);
}
var x=Math.floor(_56.x);
var y=Math.floor(_56.y);
var w=Math.floor(_56.x+_56.w+1e-11)-x;
var h=Math.floor(_56.y+_56.h+1e-11)-y;
if(_58){
_8.place(_5b,_53);
}
_9.setMarginBox(_5b,{l:x,t:y,w:w,h:h});
if(!_5a){
var box=_9.getContentBox(_5b);
this._layoutGroupContent(_5b,box.w,box.h,_57+1,_58,_59);
}
this.onRendererUpdated({renderer:_5b,item:_55,kind:_5a?"leaf":"group",level:_57});
},_layoutGroupContent:function(_5c,_5d,_5e,_5f,_60,_61){
var _62=_7(".dojoxTreeMapHeader",_5c)[0];
var _63=_7(".dojoxTreeMapGroupContent",_5c)[0];
if(_62==null||_63==null){
return;
}
var box=_9.getMarginBox(_62);
if(box.h>_5e){
box.h=_5e;
_b.set(_63,"display","none");
}else{
_b.set(_63,"display","block");
_9.setMarginBox(_63,{l:0,t:box.h,w:_5d,h:(_5e-box.h)});
this._buildChildrenRenderers(_63,_5c.item,_5f,_60,null,_61);
}
_9.setMarginBox(_62,{l:0,t:0,w:_5d,h:box.h});
},_updateGroupRenderer:function(_64,_65,_66){
var _67=_64==null;
if(_64==null){
_64=this.createRenderer("div",_66,"group");
_a.add(_64,"dojoxTreeMapGroup");
}
this.styleRenderer(_64,_65,_66,"group");
var _68=_7(".dojoxTreeMapHeader",_64)[0];
_68=this._updateHeaderRenderer(_68,_65,_66);
if(_67){
_8.place(_68,_64);
}
var _69=_7(".dojoxTreeMapGroupContent",_64)[0];
_69=this._updateGroupContentRenderer(_69,_65,_66);
if(_67){
_8.place(_69,_64);
}
return _64;
},_updateHeaderRenderer:function(_6a,_6b,_6c){
if(_6a==null){
_6a=this.createRenderer(_6b,_6c,"header");
_a.add(_6a,"dojoxTreeMapHeader");
_a.add(_6a,"dojoxTreeMapHeader_"+_6c);
}
this.styleRenderer(_6a,_6b,_6c,"header");
return _6a;
},_updateLeafRenderer:function(_6d,_6e,_6f){
if(_6d==null){
_6d=this.createRenderer(_6e,_6f,"leaf");
_a.add(_6d,"dojoxTreeMapLeaf");
_a.add(_6d,"dojoxTreeMapLeaf_"+_6f);
}
this.styleRenderer(_6d,_6e,_6f,"leaf");
var _70=this.tooltipFunc(_6e,this.store);
if(_70){
_6d.title=_70;
}
return _6d;
},_updateGroupContentRenderer:function(_71,_72,_73){
if(_71==null){
_71=this.createRenderer(_72,_73,"content");
_a.add(_71,"dojoxTreeMapGroupContent");
_a.add(_71,"dojoxTreeMapGroupContent_"+_73);
}
this.styleRenderer(_71,_72,_73,"content");
return _71;
},_getRendererFromTarget:function(_74){
var _75=_74;
while(_75!=this.domNode&&!_75.item){
_75=_75.parentNode;
}
return _75;
},_onMouseOver:function(e){
var _76=this._getRendererFromTarget(e.target);
if(_76.item){
var _77=_76.item;
this._hoveredItem=_77;
this.updateRenderers(_77);
this.onItemRollOver({renderer:_76,item:_77,triggerEvent:e});
}
},_onMouseOut:function(e){
var _78=this._getRendererFromTarget(e.target);
if(_78.item){
var _79=_78.item;
this._hoveredItem=null;
this.updateRenderers(_79);
this.onItemRollOut({renderer:_78,item:_79,triggerEvent:e});
}
},_onMouseUp:function(e){
var _7a=this._getRendererFromTarget(e.target);
if(_7a.item){
this.selectFromEvent(e,_7a.item,e.currentTarget,true);
}
},onRendererUpdated:function(){
},onItemRollOver:function(){
},onItemRollOut:function(){
},updateRenderers:function(_7b){
if(!_7b){
return;
}
if(!_2.isArray(_7b)){
_7b=[_7b];
}
for(var i=0;i<_7b.length;i++){
var _7c=_7b[i];
var _7d=this._getRenderer(_7c);
if(!_7d){
continue;
}
var _7e=this.isItemSelected(_7c);
var ie=has("ie");
var div;
if(_7e){
_a.add(_7d,"dojoxTreeMapSelected");
if(ie&&(has("quirks")||ie<9)){
div=_7d.previousSibling;
var _7f=_b.get(_7d);
if(!div||!_a.contains(div,"dojoxTreeMapIEHack")){
div=this.createRenderer(_7c,-10,"group");
_a.add(div,"dojoxTreeMapIEHack");
_a.add(div,"dojoxTreeMapSelected");
_b.set(div,{position:"absolute",overflow:"hidden"});
_8.place(div,_7d,"before");
}
var _80=2*parseInt(_b.get(div,"border-width"));
if(this._isLeaf(_7c)){
_80-=1;
}else{
_80+=1;
}
_b.set(div,{left:(parseInt(_7f["left"])+1)+"px",top:(parseInt(_7f["top"])+1)+"px",width:(parseInt(_7f["width"])-_80)+"px",height:(parseInt(_7f["height"])-_80)+"px"});
}
}else{
if(ie&&(has("quirks")||ie<9)){
div=_7d.previousSibling;
if(div&&_a.contains(div,"dojoxTreeMapIEHack")){
div.parentNode.removeChild(div);
}
}
_a.remove(_7d,"dojoxTreeMapSelected");
}
if(_7e||this._hoveredItem==_7c){
_b.set(_7d,"zIndex",20);
}else{
_b.set(_7d,"zIndex",(has("ie")<=7)?0:"auto");
}
}
}});
});
